unit frmConsole;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ActnList, Menus, Buttons, Spin, CheckLst,
  hDatabase, uDatabase, uStorage, uVarString, uSocketUtils, uStringArray,
  hXMPPD,hPOP3,hReceive,hHTTP,hDNS,hLDAP,hIMAP,hBMail,uInt64Array,uRSRServer,
  uListViewUtils;

type

  { TConsoleForm }

  TConsoleForm = class(TForm)
    btnBLDNSItemAdd: TButton;
    btnBLDNSItemRemove: TButton;
    btnClusterCancel1: TBitBtn;
    btnClusterCancel2: TBitBtn;
    btnClusterNewNodeCancel: TBitBtn;
    btnClusterNewNode: TBitBtn;
    btnCluster_Done: TBitBtn;
    btnContentTypesAdd: TButton;
    btnContentTypesRemove: TButton;
    btnDomainClusteringDone: TBitBtn;
    btnDomain_Files_Manage: TBitBtn;
    btnDomain_Files_Backup: TBitBtn;
    btnDomain_Files_Restore: TBitBtn;
    btnUser_Edit_Cancel: TBitBtn;
    btnClusterNew: TBitBtn;
    btnClusterCancel: TBitBtn;
    btnDomainsNew_OK: TBitBtn;
    btnDNSItemAdd: TButton;
    btnDNSItemRemove: TButton;
    btnDomain_Done: TBitBtn;
    btnDomain_User_New_Done: TBitBtn;
    btnDomain_User_Done: TBitBtn;
    btnHSBLAdd: TButton;
    Button10: TButton;
    Button9: TButton;
    cbDomain_Clusters: TComboBox;
    cbDomain_Nodes: TComboBox;
    cbUser_Edit_Settings: TCheckGroup;
    Edit8: TEdit;
    gbContentWordDetails1: TGroupBox;
    GroupBox19: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    lvKeywords: TListView;
    tsKeywords: TTabSheet;
    tsFileManager: TTabSheet;
    txtContentTypeKind: TEdit;
    gbContentTypeDetails: TGroupBox;
    gbDomains: TGroupBox;
    gbDomainService: TGroupBox;
    gbDomainServices: TGroupBox;
    GroupBox18: TGroupBox;
    GroupBox33: TGroupBox;
    GroupBox34: TGroupBox;
    GroupBox35: TGroupBox;
    Label103: TLabel;
    Label109: TLabel;
    Label110: TLabel;
    Label111: TLabel;
    Label112: TLabel;
    Label113: TLabel;
    Label114: TLabel;
    Label115: TLabel;
    Label116: TLabel;
    Label117: TLabel;
    Label118: TLabel;
    Label119: TLabel;
    Label77: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lvClusters: TListView;
    lvContentTypes: TListView;
    lvDomains: TListView;
    lvDomainServices: TListView;
    lvDomainNodeServices: TListView;
    lvUsers: TListView;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MI_PU_Service_LDAP: TMenuItem;
    MI_PU_Service_IMAP: TMenuItem;
    MI_PU_Service_DNS: TMenuItem;
    MI_PU_Service_HTTPS: TMenuItem;
    MI_PU_Service_HTTP: TMenuItem;
    MI_PU_Service_BMAIL: TMenuItem;
    MenuItem13: TMenuItem;
    MI_PU_Service_SMTP: TMenuItem;
    MI_PU_Service_POP3: TMenuItem;
    MI_PU_Service_XMPPS2S: TMenuItem;
    MI_PU_Service_XMPP: TMenuItem;
    MI_PU_Cluster_Delete: TMenuItem;
    MI_PU_Cluster_Edit: TMenuItem;
    MI_PU_Cluster_New: TMenuItem;
    MI_PU_Domain_User_Unlock: TMenuItem;
    MI_PU_Domain_User_Delete: TMenuItem;
    MenuItem9: TMenuItem;
    MI_PU_Domain_User_Edit: TMenuItem;
    MI_PU_Domain_User_New: TMenuItem;
    PU_Service_Kind: TPopupMenu;
    PU_Clusters: TPopupMenu;
    PU_Domain_Users: TPopupMenu;
    sbUser: TScrollBox;
    tsContentTypes: TTabSheet;
    tbbClustersDelete1: TToolButton;
    tbbClustersDelete2: TToolButton;
    tbbClustersEdit1: TToolButton;
    tbbClustersEdit2: TToolButton;
    tbbDomainServiceNew: TToolButton;
    tbbClustersNewNode: TToolButton;
    TB_Clusters1: TToolBar;
    TB_Clusters2: TToolBar;
    ToolButton10: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    tsDomainClustering: TTabSheet;
    txtCluster_Building: TEdit;
    txtCluster_City: TEdit;
    txtCluster_Country: TEdit;
    txtCluster_Floor: TEdit;
    txtCluster_Town: TEdit;
    txtCluster_Name: TEdit;
    txtCluster_New_Description: TEdit;
    txtCluster_Zipcode: TEdit;
    txtCluster_Room: TEdit;
    txtCluster_State: TEdit;
    txtCluster_Street: TEdit;
    txtCluster_Description: TEdit;
    txtContentTypeExtension: TEdit;
    txtUser_Edit_First: TEdit;
    Label89: TLabel;
    txtUsers_New_Account: TEdit;
    txtUser_Edit_Last: TEdit;
    txtUser_Edit_Password: TEdit;
    txtUsers_New_First: TEdit;
    txtUsers_New_Last: TEdit;
    GroupBox14: TGroupBox;
    gbDomain_Users_New: TGroupBox;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label84: TLabel;
    pnlDomainUserFind: TPanel;
    tbbDomain_User_Unlock: TToolButton;
    ToolButton6: TToolButton;
    tsUser: TTabSheet;
    tbbDomain_User_Delete: TToolButton;
    tbbDomain_User_Edit: TToolButton;
    tbbDomain_User_New: TToolButton;
    btnWLDNSItemAdd: TButton;
    btnWLDNSItemRemove: TButton;
    btnHSBLRemove: TButton;
    btnHSWLAdd: TButton;
    btnHSWLRemove: TButton;
    Button7: TButton;
    Button8: TButton;
    cbDomain_Service: TCheckBox;
    cbDomain_Defaults: TCheckListBox;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    gbDomainServiceSettings: TGroupBox;
    gbDomains_DomainInformation: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox31: TGroupBox;
    GroupBox32: TGroupBox;
    gbDomainAdminTableCSS: TGroupBox;
    gbAdminTextAreas: TGroupBox;
    gbDomainAdminImages: TGroupBox;
    gbDomainAdminFormCSS: TGroupBox;
    IL_24x24: TImageList;
    Label100: TLabel;
    Label101: TLabel;
    Label102: TLabel;
    Label104: TLabel;
    Label105: TLabel;
    Label4: TLabel;
    Label83: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    Label94: TLabel;
    Label95: TLabel;
    Label96: TLabel;
    Label97: TLabel;
    Label98: TLabel;
    Label99: TLabel;
    pcDomain: TPageControl;
    sbDomainStyles: TScrollBox;
    seDomainAdminTextAreaColumns: TSpinEdit;
    seDomainAdminTextAreaRowCount: TSpinEdit;
    seDomain_Default_Quota: TSpinEdit;
    ToolBar4: TToolBar;
    ToolButton1: TToolButton;
    ToolButton15: TToolButton;
    tbbDomain_Users_Find: TToolButton;
    tsDomainUsers: TTabSheet;
    tsDomainStyles: TTabSheet;
    tsDomainDefaults: TTabSheet;
    tbDomainScale: TTrackBar;
    tsDomainScale: TTabSheet;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    txtDomains_Postmaster: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit30: TEdit;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    Edit41: TEdit;
    Edit42: TEdit;
    Edit43: TEdit;
    Edit44: TEdit;
    Edit45: TEdit;
    Edit46: TEdit;
    Edit47: TEdit;
    Edit48: TEdit;
    Edit49: TEdit;
    Edit50: TEdit;
    Edit51: TEdit;
    Edit52: TEdit;
    Edit53: TEdit;
    Edit54: TEdit;
    Edit55: TEdit;
    Edit56: TEdit;
    Edit57: TEdit;
    Edit58: TEdit;
    Edit59: TEdit;
    txtDomains_FriendlyName: TEdit;
    txtCluster_New_Name: TEdit;
    Edit64: TEdit;
    Edit65: TEdit;
    Edit66: TEdit;
    Edit67: TEdit;
    txtDomains_Hostname: TEdit;
    cbClusters_ClusterInfo: TGroupBox;
    GroupBox15: TGroupBox;
    GroupBox16: TGroupBox;
    GroupBox17: TGroupBox;
    GroupBox23: TGroupBox;
    GroupBox24: TGroupBox;
    GroupBox25: TGroupBox;
    GroupBox26: TGroupBox;
    GroupBox27: TGroupBox;
    GroupBox28: TGroupBox;
    GroupBox29: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox30: TGroupBox;
    Label16: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    lvDNSRegular: TListView;
    lvDNSBL: TListView;
    lvDNSWL: TListView;
    TabSheet10: TTabSheet;
    tsPrefDTDomains: TTabSheet;
    tsPrefDTUsers: TTabSheet;
    TabSheet13: TTabSheet;
    tsPrefDTRSS: TTabSheet;
    tsPrefDTSearch: TTabSheet;
    TabSheet21: TTabSheet;
    tsPrefDTClusters: TTabSheet;
    txtDomain_Admin_Table: TEdit;
    txtDomain_Admin_Logs: TEdit;
    txtDomain_Admin_GoButton: TEdit;
    txtDomain_Admin_Combo: TEdit;
    txtDomain_Admin_Inputs: TEdit;
    txtDomain_Admin_Table_Header: TEdit;
    txtDomain_Admin_Table_Rows: TEdit;
    txtDomain_Admin_Table_Cells: TEdit;
    txtDomain_Admin_Table_Seps: TEdit;
    txtDomain_Admin_Table_Footers: TEdit;
    txtDomain_Admin_Table_Images: TEdit;
    txtDomain_Admin_RSS: TEdit;
    txtDomain_Admin_Calendar: TEdit;
    txtClusterNodeName: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    txtDomain_FriendlyName: TEdit;
    cbDomain_Host: TComboBox;
    txtDomain_Postmaster: TEdit;
    Image1: TImage;
    Label61: TLabel;
    Label62: TLabel;
    tsWelcome: TTabSheet;
    txtHSBLHI: TEdit;
    txtHSWLHI: TEdit;
    Edit7: TEdit;
    GroupBox1: TGroupBox;
    GroupBox10: TGroupBox;
    GroupBox11: TGroupBox;
    gbClustersNewNode: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    gbContentWordDetails: TGroupBox;
    Label1: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lvHSBL: TListView;
    lvHSWL: TListView;
    lvContentFilters: TListView;
    lvClusterNodes: TListView;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MI_File_New_Domain: TMenuItem;
    MI_File_New_Cluster: TMenuItem;
    MI_File_New_Node: TMenuItem;
    MI_File_New_User: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MI_File_New: TMenuItem;
    pcPages: TPageControl;
    Splitter1: TSplitter;
    StatusBar: TStatusBar;
    tsDomains: TTabSheet;
    tsDomain: TTabSheet;
    tsPrefDNS: TTabSheet;
    TabSheet5: TTabSheet;
    tsCluster: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    ToolBar2: TToolBar;
    TB_Clusters: TToolBar;
    ToolButton11: TToolButton;
    btnDomainsNew: TToolButton;
    ToolButton3: TToolButton;
    btnDomainsDelete: TToolButton;
    btnDomainsEdit: TToolButton;
    tbbClustersNew: TToolButton;
    tbbClustersDelete: TToolButton;
    tbbClustersEdit: TToolButton;
    tvNavigation: TTreeView;
    txtUsersFind: TEdit;
    txtUsers_New_Password: TEdit;
    txtUser_Edit_Telephone: TEdit;
    procedure btnBLDNSItemAddClick(Sender: TObject);
    procedure btnClusterCancel1Click(Sender: TObject);
    procedure btnClusterCancel2Click(Sender: TObject);
    procedure btnClusterCancelClick(Sender: TObject);
    procedure btnClusterNewClick(Sender: TObject);
    procedure btnClusterNewNodeCancelClick(Sender: TObject);
    procedure btnClusterNewNodeClick(Sender: TObject);
    procedure btnDomainsDeleteClick(Sender: TObject);
    procedure btnDomain_Files_ManageClick(Sender: TObject);
    procedure btnDomain_User_DoneClick(Sender: TObject);
    procedure btnService_IP_DoneClick(Sender: TObject);
    procedure btnUser_Edit_CancelClick(Sender: TObject);
    procedure btnDomainsNew_OKClick(Sender: TObject);
    procedure btnDomainsEditClick(Sender: TObject);
    procedure btnDomainsNewClick(Sender: TObject);
    procedure btnDomain_DoneClick(Sender: TObject);
    procedure btnDomain_User_New_DoneClick(Sender: TObject);
    procedure btnUsersFindClick(Sender: TObject);
    procedure btnWLDNSItemAddClick(Sender: TObject);
    procedure btnDNSItemAddClick(Sender: TObject);
    procedure btnBLDNSItemRemoveClick(Sender: TObject);
    procedure btnWLDNSItemRemoveClick(Sender: TObject);
    procedure btnDNSItemRemoveClick(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure cbDomain_ClustersChange(Sender: TObject);
    procedure cbDomain_DefaultsClick(Sender: TObject);
    procedure cbDomain_DefaultsItemClick(Sender: TObject; Index: integer);
    procedure cbDomain_ServiceChange(Sender: TObject);
    procedure E(Sender: TObject; var Key: char);
    procedure Edit13Change(Sender: TObject);
    procedure Edit13KeyPress(Sender: TObject; var Key: char);
    procedure Edit14Change(Sender: TObject);
    procedure Edit15Change(Sender: TObject);
    procedure Edit15KeyPress(Sender: TObject; var Key: char);
    procedure Edit16Change(Sender: TObject);
    procedure Edit17Change(Sender: TObject);
    procedure Edit18Change(Sender: TObject);
    procedure Edit19Change(Sender: TObject);
    procedure Edit21Change(Sender: TObject);
    procedure Edit22Change(Sender: TObject);
    procedure Edit23Change(Sender: TObject);
    procedure Edit24Change(Sender: TObject);
    procedure Edit25Change(Sender: TObject);
    procedure Edit26Change(Sender: TObject);
    procedure Edit27Change(Sender: TObject);
    procedure Edit28Change(Sender: TObject);
    procedure Edit29Change(Sender: TObject);
    procedure Edit30Change(Sender: TObject);
    procedure Edit31Change(Sender: TObject);
    procedure Edit32Change(Sender: TObject);
    procedure Edit33Change(Sender: TObject);
    procedure Edit34Change(Sender: TObject);
    procedure Edit35Change(Sender: TObject);
    procedure Edit36Change(Sender: TObject);
    procedure Edit37Change(Sender: TObject);
    procedure Edit38Change(Sender: TObject);
    procedure Edit39Change(Sender: TObject);
    procedure Edit40Change(Sender: TObject);
    procedure Edit41Change(Sender: TObject);
    procedure Edit42Change(Sender: TObject);
    procedure Edit43Change(Sender: TObject);
    procedure Edit44Change(Sender: TObject);
    procedure Edit45Change(Sender: TObject);
    procedure Edit46Change(Sender: TObject);
    procedure Edit47Change(Sender: TObject);
    procedure Edit48Change(Sender: TObject);
    procedure Edit49Change(Sender: TObject);
    procedure Edit50Change(Sender: TObject);
    procedure Edit51Change(Sender: TObject);
    procedure Edit52Change(Sender: TObject);
    procedure Edit53Change(Sender: TObject);
    procedure Edit54Change(Sender: TObject);
    procedure Edit55Change(Sender: TObject);
    procedure Edit56Change(Sender: TObject);
    procedure Edit57Change(Sender: TObject);
    procedure Edit58Change(Sender: TObject);
    procedure Edit59Change(Sender: TObject);
    procedure Edit64Change(Sender: TObject);
    procedure Edit65Change(Sender: TObject);
    procedure Edit66Change(Sender: TObject);
    procedure Edit67Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure gbClustersNewNodeClick(Sender: TObject);
    procedure gbDomainServiceSettingsClick(Sender: TObject);
    procedure gbDomainServiceClick(Sender: TObject);
    procedure GroupBox3Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
    procedure lvContentTypesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvDNSBLSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvDNSWLSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvDomainsColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvDomainsCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure lvDomainsDblClick(Sender: TObject);
    procedure lvDomainServicesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvDNSRegularSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvHSBLSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvHSWLSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvClusterNodesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvUsersDblClick(Sender: TObject);
    procedure lvUsersSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure MenuItem9Click(Sender: TObject);
    procedure MI_File_New_ClusterClick(Sender: TObject);
    procedure MI_File_New_NodeClick(Sender: TObject);
    procedure MI_File_New_UserClick(Sender: TObject);
    procedure MenuItem17Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MI_File_NewClick(Sender: TObject);
    procedure MI_PU_Domain_User_DeleteClick(Sender: TObject);
    procedure pcDomainChange(Sender: TObject);
    procedure pcDomainChanging(Sender: TObject; var AllowChange: Boolean);
    procedure pcPagesChange(Sender: TObject);
    procedure PU_ClustersPopup(Sender: TObject);
    procedure PU_Domain_UsersPopup(Sender: TObject);
    procedure sbUserClick(Sender: TObject);
    procedure seDomainAdminTextAreaColumnsChange(Sender: TObject);
    procedure seDomain_Default_QuotaChange(Sender: TObject);
    procedure StatusBarResize(Sender: TObject);
    procedure TabSheet5ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tsPrefDTSearchContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tbbClustersDeleteClick(Sender: TObject);
    procedure tbbClustersEdit2Click(Sender: TObject);
    procedure tbbClustersEditClick(Sender: TObject);
    procedure tbbDomainServiceNewClick(Sender: TObject);
    procedure tbbClustersNewClick(Sender: TObject);
    procedure tbbDomain_Users_FindClick(Sender: TObject);
    procedure tbbDomain_User_DeleteClick(Sender: TObject);
    procedure tbbDomain_User_NewClick(Sender: TObject);
    procedure tbbDomain_User_UnlockClick(Sender: TObject);
    procedure tbDomainScaleChange(Sender: TObject);
    procedure tsDomainUsersContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tsWelcomeContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure tvNavigationSelectionChanged(Sender: TObject);
    procedure txtClusterNodeNameChange(Sender: TObject);
    procedure txtCluster_BuildingChange(Sender: TObject);
    procedure txtCluster_CityChange(Sender: TObject);
    procedure txtCluster_CountryChange(Sender: TObject);
    procedure txtCluster_FloorChange(Sender: TObject);
    procedure txtCluster_NameChange(Sender: TObject);
    procedure txtCluster_New_NameChange(Sender: TObject);
    procedure txtCluster_RoomChange(Sender: TObject);
    procedure txtCluster_StateChange(Sender: TObject);
    procedure txtCluster_StreetChange(Sender: TObject);
    procedure txtCluster_TownChange(Sender: TObject);
    procedure txtCluster_ZipcodeChange(Sender: TObject);
    procedure txtContentTypeExtensionChange(Sender: TObject);
    procedure txtContentTypeKindChange(Sender: TObject);
    procedure txtDomains_FriendlyNameChange(Sender: TObject);
    procedure txtDomains_HostnameChange(Sender: TObject);
    procedure txtDomains_PostmasterChange(Sender: TObject);
    procedure txtDomain_Admin_CalendarChange(Sender: TObject);
    procedure txtDomain_Admin_ComboChange(Sender: TObject);
    procedure txtDomain_Admin_GoButtonChange(Sender: TObject);
    procedure txtDomain_Admin_InputsChange(Sender: TObject);
    procedure txtDomain_Admin_LogsChange(Sender: TObject);
    procedure txtDomain_Admin_RSSChange(Sender: TObject);
    procedure txtDomain_Admin_TableChange(Sender: TObject);
    procedure txtDomain_Admin_Table_CellsChange(Sender: TObject);
    procedure txtDomain_Admin_Table_FootersChange(Sender: TObject);
    procedure txtDomain_Admin_Table_HeaderChange(Sender: TObject);
    procedure txtDomain_Admin_Table_ImagesChange(Sender: TObject);
    procedure txtDomain_Admin_Table_RowsChange(Sender: TObject);
    procedure txtDomain_Admin_Table_SepsChange(Sender: TObject);
    procedure txtDomain_FriendlyNameChange(Sender: TObject);
    procedure cbDomain_HostChange(Sender: TObject);
    procedure txtDomain_PostmasterChange(Sender: TObject);
    procedure txtHSBLHIChange(Sender: TObject);
    procedure txtUsersFindKeyPress(Sender: TObject; var Key: char);
    procedure txtUsers_New_AccountChange(Sender: TObject);
    procedure txtUsers_New_FirstChange(Sender: TObject);
    procedure txtUser_Edit_FirstChange(Sender: TObject);
    procedure txtUser_Edit_LastChange(Sender: TObject);
    procedure txtUser_Edit_PasswordChange(Sender: TObject);
    procedure txtUser_Edit_TelephoneChange(Sender: TObject);
  private
    FLoading                         : boolean; // Disable Writing during GUI Loads
    FTempScale                       : integer;
    FDNS_HOST_IP                     : TStringArray; // Preferences/DNS Servers
    FDNS_BL_IP                       : TStringArray; // Security/DNS BlackLists
    FDNS_WL_IP                       : TStringArray; // Security/DNS WhiteLists
    // Security Features
    Security_Content_Filters         : TFilterItems;
    Security_Block_List              : TFilterItems;
    Security_Allow_List              : TFilterItems;
    // DNS Servers (Regular, BlackLists, WhiteLists)
    DNS_Hosts                        : TDNSItems;
    DNS_BlackLists                   : TDNSItems;
    DNS_WhiteLists                   : TDNSItems;
    // Users
    Accounts                         : TUAList;
    // Domains
    Domains                          : TDomains;
    FDomainP                         : PDomain;
    FClusterP                        : PMatrixCluster;
    FNodeP                           : PMatrixNode;
    FUserP                           : PUserAccount;
    FDomainNodes                     : TMatrixNodes; // Must use master node list
    FDomainServices                  : TMatrixServices;
    // Services
    Services                         : TMatrixServices;
    // Clusters
    Clusters                         : TMatrixClusters;
    FClusterNodes                    : TMatrixNodes;
    FClusterNodeP                    : PMatrixNode;
    FClusterNode_IP                  : TStringArray;
    // Nodes
    Nodes                            : TMatrixNodes;
    FNode_IP                         : TStringArray;
  private
    { private declarations }
    function LocatePage(sString:string):TTabsheet;
    function ParseNodesForPath(Node:TTreeNode):string;
    procedure UpdateSelectedDNSServer(Kind:Byte);
  public
    { public declarations }
    procedure LoadSettings;
    procedure LoadDomains;
    procedure LoadClusters;
    procedure LoadContentTypes;
    procedure LoadNodes;       // Master List
    procedure Display_Welcome;
    procedure Display_Domain_Editor(DomainP:PDomain);
    procedure Display_Cluster_Editor(ClusterP:PMatrixCluster);
  end;

var
  ConsoleForm: TConsoleForm;

implementation
uses frmLogin,frmYesNo,frmFileMan;

{ TConsoleForm }

procedure TConsoleForm.Display_Welcome;
begin
  tvNavigation.Selected:=tvNavigation.Items.GetFirstNode;
end;

function TConsoleForm.ParseNodesForPath(Node:TTreeNode):string;
begin
  SetLength(Result,0);
  if Node<>nil then
    Result:=Concat(ParseNodesForPath(Node.Parent),'/',Node.Text);
end;

function TConsoleForm.LocatePage(sString:string):TTabsheet;
var
  iLcv:integer;
begin
  Result:=nil; iLcv:=0;
  while (iLcv<pcPages.PageCount) and (Result=nil) do begin
    if SameText(sString,pcPages.Pages[iLcv].Caption) then
      Result:=pcPages.Pages[iLcv];
    inc(iLcv);
  end;
end;

procedure TConsoleForm.tvNavigationSelectionChanged(Sender: TObject);
var
  sPath:string;
begin
  // Select propper page.
  if tvNavigation.Selected<>nil then begin
    sPath:=ParseNodesForPath(tvNavigation.Selected);
    pcPages.ActivePage:=LocatePage(sPath);
  end;
end;

procedure TConsoleForm.txtClusterNodeNameChange(Sender: TObject);
begin
  if FLoading then exit;
  btnClusterNewNode.Enabled:=Length(txtClusterNodeName.Text)>0;
end;

procedure TConsoleForm.txtCluster_BuildingChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Building.Text,@FClusterP^.Location.Building);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_CityChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_City.Text,@FClusterP^.Location.Area);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_CountryChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Country.Text,@FClusterP^.Location.Country);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_FloorChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Floor.Text,@FClusterP^.Location.Floor);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_NameChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Name.Text,@FClusterP^.Group);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_New_NameChange(Sender: TObject);
begin
  btnClusterNew.Enabled:=(Length(txtCluster_New_Name.Text)>0);
end;

procedure TConsoleForm.txtCluster_RoomChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Room.Text,@FClusterP^.Location.Room);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_StateChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_State.Text,@FClusterP^.Location.Region);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_StreetChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Town.Text,@FClusterP^.Location.Street);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_TownChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Town.Text,@FClusterP^.Location.Locality);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtCluster_ZipcodeChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtCluster_Zipcode.Text,@FClusterP^.Location.Zip);
  uStorage.Cluster_Save(FClusterP^);
end;

procedure TConsoleForm.txtContentTypeExtensionChange(Sender: TObject);
var
  ContentP:PContentType;
begin
  if FLoading then exit;
  btnContentTypesAdd.Enabled:=hHTTP.Validate(uStorage.ContentTypes,txtContentTypeKind.Text,txtContentTypeExtension.Text,ctvAdd);
  {$i frmConsole.ContentTypes.UpdateSelected.inc}
end;

procedure TConsoleForm.txtContentTypeKindChange(Sender: TObject);
var
  ContentP:PContentType;
begin
  if FLoading then exit;
  btnContentTypesAdd.Enabled:=hHTTP.Validate(uStorage.ContentTypes,txtContentTypeKind.Text,txtContentTypeExtension.Text,ctvAdd);
  {$i frmConsole.ContentTypes.UpdateSelected.inc}
end;

procedure TConsoleForm.txtDomains_FriendlyNameChange(Sender: TObject);
begin
  {$i frmConsole.Domains.New.Input.Verify.inc}
end;

procedure TConsoleForm.txtDomains_HostnameChange(Sender: TObject);
begin
  {$i frmConsole.Domains.New.Input.Verify.inc}
end;

procedure TConsoleForm.txtDomains_PostmasterChange(Sender: TObject);
begin
  {$i frmConsole.Domains.New.Input.Verify.inc}
end;

procedure TConsoleForm.txtDomain_Admin_CalendarChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Calendar.Text,@FDomainP^.Admin.CalIconURL);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_ComboChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Combo.Text,@FDomainP^.Admin.ComboClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_GoButtonChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_GoButton.Text,@FDomainP^.Admin.GoButtonURL);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_InputsChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Inputs.Text,@FDomainP^.Admin.InputClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_LogsChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Logs.Text,@FDomainP^.Admin.StatsIconURL);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_RSSChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_RSS.Text,@FDomainP^.Admin.RSSIconURL);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_TableChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table.Text,@FDomainP^.Admin.TableClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_CellsChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Cells.Text,@FDomainP^.Admin.TDClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_FootersChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Footers.Text,@FDomainP^.Admin.TFClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_HeaderChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Header.Text,@FDomainP^.Admin.THClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_ImagesChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Images.Text,@FDomainP^.Admin.TIClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_RowsChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Rows.Text,@FDomainP^.Admin.TRClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_Admin_Table_SepsChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Admin_Table_Seps.Text,@FDomainP^.Admin.TSClass);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtDomain_FriendlyNameChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_FriendlyName.Text,@FDomainP^.FriendlyName);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.cbDomain_HostChange(Sender: TObject);
var
  iIndex:Integer;
begin
  if FLoading then exit;
  // Technically we're changing the current domain to another domain.
  // We can do lookups later but for now just a combo box.
  iIndex:=uStorage.IndexOf(Domains,cbDomain_Host.Text);
  if iIndex<>-1 then
    Display_Domain_Editor(@Domains[iIndex]);
end;

procedure TConsoleForm.txtDomain_PostmasterChange(Sender: TObject);
begin
  if FLoading then exit;
  uVarString.fromString(txtDomain_Postmaster.Text,@FDomainP^.Root);
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.txtHSBLHIChange(Sender: TObject);
begin

end;

procedure TConsoleForm.txtUsersFindKeyPress(Sender: TObject; var Key: char);
begin
  if Key=#13 then
    tbbDomain_Users_Find.Click;
end;

procedure TConsoleForm.txtUsers_New_AccountChange(Sender: TObject);
var
  vsAccount:TVarString;
begin
  if FLoading then exit;
  uVarString.fromString(txtUsers_New_Account.Text,@vsAccount);
  Try
    btnDomain_User_New_Done.Enabled:=(Length(vsAccount)>0) and (Not uStorage.UserAccount_Exists(uStorage.Module,vsAccount,FDomainP^.ID));
  finally
    Empty(vsAccount);
  end;
end;

procedure TConsoleForm.txtUsers_New_FirstChange(Sender: TObject);
begin

end;

procedure TConsoleForm.txtUser_Edit_FirstChange(Sender: TObject);
begin
  if FLoading then Exit;
end;

procedure TConsoleForm.txtUser_Edit_LastChange(Sender: TObject);
begin
  if FLoading then Exit;
end;

procedure TConsoleForm.txtUser_Edit_PasswordChange(Sender: TObject);
begin
  if FLoading then Exit;
end;

procedure TConsoleForm.txtUser_Edit_TelephoneChange(Sender: TObject);
begin
  if FLoading then exit;
end;

procedure TConsoleForm.MenuItem2Click(Sender: TObject);
begin
  uDatabase.Disconnect(Module.SessionID);
  Application.Terminate;
end;

procedure TConsoleForm.lvHSBLSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if Item<>nil then
    txtHSBLHI.Text:=Item.Caption
  else
    txtHSBLHI.Clear;
end;

procedure TConsoleForm.FormCreate(Sender: TObject);
begin
  Visible:=false;
  FLoading:=true;
  pcPages.ShowTabs:=false;
  pcPages.ActivePage:=tsWelcome;
  FLoading:=false;
  SetLength(FDNS_HOST_IP,4);
  SetLength(FDNS_BL_IP,4);
  SetLength(FDNS_WL_IP,4);
  tsUser.TabVisible:=false;
  Visible:=False;
end;

procedure TConsoleForm.FormDestroy(Sender: TObject);
begin
  Empty(FDNS_HOST_IP);
  Empty(FDNS_BL_IP);
  Empty(FDNS_WL_IP);
  Empty(FNode_IP);
  Empty(FClusterNode_IP);
  Empty(Accounts);
  Empty(Domains);
  Empty(Clusters);
  Empty(Nodes);
  Empty(Services);
  Empty(FDomainNodes);
  Empty(FDomainServices);
end;

procedure TConsoleForm.gbClustersNewNodeClick(Sender: TObject);
begin

end;

procedure TConsoleForm.gbDomainServiceSettingsClick(Sender: TObject);
begin

end;

procedure TConsoleForm.gbDomainServiceClick(Sender: TObject);
begin

end;

procedure TConsoleForm.GroupBox3Click(Sender: TObject);
begin

end;

procedure TConsoleForm.Label19Click(Sender: TObject);
begin

end;

procedure TConsoleForm.lvContentTypesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  {$i frmConsole.ContentTypes.SelectItem.inc}
end;

procedure TConsoleForm.lvDNSBLSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  iLen:integer;
begin
  FLoading:=true;
  Try
    Selected:=Item<>nil;
    if Selected then begin
      Edit32.Enabled:=true;
      Edit33.Enabled:=true;
      Edit38.Enabled:=true;
      Edit59.Enabled:=true;

      uStringArray.fromString(@FDNS_BL_IP,Item.Caption,'.');
      SetLength(FDNS_BL_IP,4);// Add or truncate
      // Assign Editor
      Edit32.Text:=FDNS_BL_IP[0];
      Edit33.Text:=FDNS_BL_IP[1];
      Edit38.Text:=FDNS_BL_IP[2];
      Edit59.Text:=FDNS_BL_IP[3];
      btnBLDNSItemAdd.Enabled:=true;
      btnBLDNSItemRemove.Enabled:=true;
    end else begin
      Edit32.Clear;
      Edit33.Clear;
      Edit38.Clear;
      Edit59.Clear;
      Edit32.Enabled:=false;
      Edit33.Enabled:=false;
      Edit38.Enabled:=false;
      Edit59.Enabled:=false;
      btnBLDNSItemAdd.Enabled:=true;
      btnBLDNSItemRemove.Enabled:=false;
    end;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.lvDNSWLSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  iLen:integer;
begin
  FLoading:=true;
  Try
    Selected:=Item<>nil;
    if Selected then begin
      Edit64.Enabled:=true;
      Edit65.Enabled:=true;
      Edit66.Enabled:=true;
      Edit67.Enabled:=true;

      uStringArray.fromString(@FDNS_WL_IP,Item.Caption,'.');
      SetLength(FDNS_WL_IP,4);// Add or truncate
      // Assign Editor
      Edit64.Text:=FDNS_WL_IP[0];
      Edit65.Text:=FDNS_WL_IP[1];
      Edit66.Text:=FDNS_WL_IP[2];
      Edit67.Text:=FDNS_WL_IP[3];

      btnWLDNSItemAdd.Enabled:=true;
      btnWLDNSItemRemove.Enabled:=true;
    end else begin
      Edit64.Clear;
      Edit65.Clear;
      Edit66.Clear;
      Edit67.Clear;
      Edit64.Enabled:=false;
      Edit65.Enabled:=false;
      Edit66.Enabled:=false;
      Edit67.Enabled:=false;
      btnWLDNSItemAdd.Enabled:=true;
      btnWLDNSItemRemove.Enabled:=false;
    end;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.lvDomainsColumnClick(Sender: TObject; Column: TListColumn
  );
begin
  lvDomains.SortColumn:=Column.Index;
end;

procedure TConsoleForm.lvDomainsCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
begin
  Compare:=CompareText(Item1.Caption,Item2.Caption);
end;

procedure TConsoleForm.lvDomainsDblClick(Sender: TObject);
begin

end;

procedure TConsoleForm.Edit17Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_Domains:=Edit17.text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.btnDNSItemAddClick(Sender: TObject);
var
  iIndex:integer;
  liDNS:TListItem;
begin
  iIndex:=Length(DNS_Hosts);
  SetLength(DNS_Hosts,iIndex+1);
  DNS_Hosts[iIndex].Kind:=uStorage.dnskRegular;
  DNS_Hosts[iIndex].ID:=0;
  DNS_Hosts[iIndex].IP:=0;

  uStorage.Config_DNS_Add(uStorage.Module,DNS_Hosts[iIndex]);
  liDNS:=lvDNSRegular.Items.Add;
  liDNS.Caption:='0.0.0.0';
  liDNS.SubItems.Add(IntToStr(DNS_Hosts[iIndex].ID));
end;

procedure TConsoleForm.btnBLDNSItemRemoveClick(Sender: TObject);
var
  iID:Int64;
  iIndex:integer;
begin
  FLoading:=true;
  Try
    btnBLDNSItemAdd.Enabled:=true;
    btnBLDNSItemRemove.Enabled:=false;
    Edit32.Clear;
    Edit33.Clear;
    Edit38.Clear;
    Edit59.Clear;
    if lvDNSBL.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSBL.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_BlackLists,iID);
      if iIndex<>-1 then begin
        uStorage.Config_DNS_Delete(uStorage.Module,DNS_BlackLists[iIndex]);
        uStorage.Remove(DNS_BlackLists,iIndex);
        lvDNSBL.Selected.Delete;
      end;
    end;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.btnWLDNSItemRemoveClick(Sender: TObject);
var
  iID:Int64;
  iIndex:integer;
begin
  FLoading:=true;
  Try
    btnWLDNSItemAdd.Enabled:=true;
    btnWLDNSItemRemove.Enabled:=false;
    Edit64.Clear;
    Edit65.Clear;
    Edit66.Clear;
    Edit67.Clear;
    if lvDNSWL.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSWL.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_WhiteLists,iID);
      if iIndex<>-1 then begin
        uStorage.Config_DNS_Delete(uStorage.Module,DNS_WhiteLists[iIndex]);
        uStorage.Remove(DNS_WhiteLists,iIndex);
        lvDNSWL.Selected.Delete;
      end;
    end;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.btnBLDNSItemAddClick(Sender: TObject);
var
  iIndex:integer;
  liDNS:TListItem;
begin
  iIndex:=Length(DNS_BlackLists);
  SetLength(DNS_BlackLists,iIndex+1);
  DNS_BlackLists[iIndex].Kind:=uStorage.dnskBlackList;
  DNS_BlackLists[iIndex].ID:=0;
  DNS_BlackLists[iIndex].IP:=0;

  uStorage.Config_DNS_Add(uStorage.Module,DNS_BlackLists[iIndex]);
  liDNS:=lvDNSBL.Items.Add;
  liDNS.Caption:='0.0.0.0';
  liDNS.SubItems.Add(IntToStr(DNS_BlackLists[iIndex].ID));
  lvDNSBL.Selected:=liDNS;
end;

procedure TConsoleForm.btnClusterCancel1Click(Sender: TObject);
begin
  FLoading:=True;
  Try
    txtDomains_Hostname.Clear;
    txtDomains_FriendlyName.Clear;
    txtDomains_Postmaster.Clear;
    gbDomains_DomainInformation.Visible:=False;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.btnClusterCancel2Click(Sender: TObject);
begin
  FLoading:=True;
  Try
    {$i frmConsole.Domains.Users.Clear.inc}
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.btnClusterCancelClick(Sender: TObject);
begin
  cbClusters_ClusterInfo.Visible:=false;
  txtCluster_New_Name.Clear;
  txtCluster_New_Description.Clear;
end;

procedure TConsoleForm.btnClusterNewClick(Sender: TObject);
var
  Cluster:TMatrixCluster;
  iIndex:Integer;

begin
  Try
    uVarString.fromString(txtCluster_New_Name.Text,@Cluster.Group);
    uVarString.fromString(txtCluster_New_Description.Text,@Cluster.Location.Description);
    if uStorage.Cluster_Create(Cluster) then begin
      txtCluster_Name.Clear;
      txtCluster_New_Description.Clear;
      iIndex:=Length(Clusters);
      SetLength(Clusters,iIndex+1);
      Copy(Cluster,Clusters[iIndex]);
      Display_Cluster_Editor(@Clusters[iIndex]);
    end;
  finally
    Empty(Cluster);
  end;
end;

procedure TConsoleForm.btnClusterNewNodeCancelClick(Sender: TObject);
begin
  FLoading:=true;
  Try
    gbClustersNewNode.Visible:=false;
    txtClusterNodeName.Clear;
    Edit13.Clear;
    Edit14.Clear;
    Edit15.Clear;
    Edit16.Clear;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.btnClusterNewNodeClick(Sender: TObject);
var
  iIndex:integer;
  liNode:TListItem;
begin
  FLoading:=True; liNode:=nil;
  Try
    if FClusterNodeP=nil then begin
       iIndex:=Length(FClusterNodes);
       SetLength(FClusterNodes,iIndex+1);
       FClusterNodeP:=@FClusterNodes[iIndex];
       FClusterNodeP^.ClusterID:=FClusterP^.ID;
       FClusterNodeP^.IP:=uSocketUtils.InAddrFromStr(FClusterNode_IP);
       fromString(txtClusterNodeName.Text,@FClusterNodeP^.Alias);
       uStorage.MatrixNode_Create(FClusterNodeP^);
       liNode:=lvClusterNodes.Items.Add;
       liNode.Caption:=txtClusterNodeName.Text;
       liNode.SubItems.Add(uSocketUtils.InAddrToStr(FClusterNodeP^.IP));
       liNode.Data:=Pointer(FClusterNodeP^.ID);
    end else begin;
      IndexOf(lvClusterNodes,Pointer(FClusterNodeP^.ID),liNode);
      FClusterNodeP^.IP:=uSocketUtils.InAddrFromStr(FClusterNode_IP);
      fromString(txtClusterNodeName.Text,@FClusterNodeP^.Alias);
      uStorage.MatrixNode_Set(FClusterNodeP^);
      if (liNode<>nil) then begin
        liNode.Caption:=txtClusterNodeName.Text;
        liNode.SubItems[0]:=uSocketUtils.InAddrToStr(FClusterNodeP^.IP);
      end;
    end;
    Edit13.Clear;
    Edit14.Clear;
    Edit15.Clear;
    Edit16.Clear;
    txtClusterNodeName.Clear;
    gbClustersNewNode.Visible:=false;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.btnDomainsDeleteClick(Sender: TObject);
var
  iIndex:integer;
begin
  if lvDomains.Selected=nil then exit;

  if frmYesNo.ShowMessage(
    Format(FMT_CONFIRM_DOMAIN_DELETE_CAPTION,[lvDomains.Selected.Caption]),
    Format(FMT_CONFIRM_DOMAIN_DELETE_TITLE,[lvDomains.Selected.Caption]),
    Format(FMT_CONFIRM_DOMAIN_DELETE_MESSAGE,[lvDomains.Selected.Caption])
  )= mrYes then begin
    FDomainP:=lvDomains.Selected.Data;
    uStorage.Domain_Delete(uStorage.Module,FDomainP^);
    iIndex:=cbDomain_Host.Items.IndexOf(lvDomains.Selected.Caption);
    if iIndex<>-1 then
      cbDomain_Host.Items.Delete(iIndex);
    lvDomains.Selected.Delete;
    FDomainP:=nil;
  end;
end;

procedure TConsoleForm.btnDomain_Files_ManageClick(Sender: TObject);
begin
  frmFileMan.FileManager.ShowModal(cbDomain_Host.Text);
end;

procedure TConsoleForm.btnDomain_User_DoneClick(Sender: TObject);
var
 iLcv:integer;
begin
  // This account is edited.  Write settings and Save item...
  FLoading:=True;
  Try
    {$i frmConsole.Domain.Users.User.Write.inc}
    uStorage.UserAccount_Save(uStorage.Module,FUserP^);
    {$i frmConsole.Domain.Users.User.Clear.inc}
    if lvUsers.Selected<>nil then begin
      lvUsers.Selected.SubItems[0]:=uVarString.toString(FUserP^.First);
      lvUsers.Selected.SubItems[1]:=uVarString.toString(FUserP^.Last);
      lvUsers.Selected.SubItems[2]:=uVarString.toString(FUserP^.Telephone);
    end;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.btnService_IP_DoneClick(Sender: TObject);
begin

end;

procedure TConsoleForm.btnUser_Edit_CancelClick(Sender: TObject);
var
  iLcv:integer;
begin
  {$i frmConsole.Domain.Users.User.Clear.inc}
end;

procedure TConsoleForm.btnDomainsNew_OKClick(Sender: TObject);
var
  iLen:Integer;
  Domain:TDomain;
  liItem:TListItem;
begin
  if uStorage.Domain_IsInternal(uStorage.Module,txtDomains_Hostname.Text) then begin
    // Domain is already present.  Display Edit mode Yes No here
  end else begin
    // Ok do go ahead and add domain into system
    Domain.CalendarConfigP:=nil;
    Domain.FeedsP:=nil;
    Domain.EventsP:=nil;
    Empty(Domain);
    Try
      uVarString.FromString(txtDomains_Hostname.Text,@Domain.Domain);
      uVarString.FromString(txtDomains_FriendlyName.Text,@Domain.FriendlyName);
      uVarString.FromString(txtDomains_Postmaster.Text,@Domain.Root);
      if uStorage.Domain_Create(uStorage.Module,Domain) then begin
        // First Create New Postmaster Account.
        uStorage.UserAccount_Create(uStorage.Module,@Domain);
        // Close this little window and present them with the screen with
        // more advanced options.
        iLen:=Length(Domains);
        SetLength(Domains,iLen+1);
        Copy(Domain,Domains[iLen]);
        liItem:=lvDomains.Items.Add;
        liItem.Caption:=txtDomains_Hostname.Text;
        liItem.SubItems.Add('1');
        liItem.Data:=@Domains[iLen];
        cbDomain_Host.Items.Add(liItem.Caption);

        gbDomains_DomainInformation.Visible:=false;
        Display_Domain_Editor(@Domains[iLen]);
      end;
    finally
      Empty(Domain);
    end;
  end;
end;

procedure TConsoleForm.btnDomainsEditClick(Sender: TObject);
var
  iIndex:Integer;
begin
  if lvDomains.Selected<>nil then begin
    FLoading:=True;
    Try
      FDomainP:=lvDomains.Selected.Data;
      Display_Domain_Editor(FDomainP);
    finally
      FLoading:=false;
    end;
  end;
end;

procedure TConsoleForm.btnDomainsNewClick(Sender: TObject);
begin
  FLoading:=True;
  Try
    txtDomains_Hostname.Clear;
    txtDomains_FriendlyName.Clear;
    txtDomains_Postmaster.Text:='postmaster';

    gbDomains_DomainInformation.Visible:=true;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.btnDomain_DoneClick(Sender: TObject);
begin

end;

procedure TConsoleForm.btnDomain_User_New_DoneClick(Sender: TObject);
var
  UA:TUserAccount;
  liItem:TListItem;
  iIndex:integer;
begin
  // Check to see if User is already present
  Init(UA);
  uVarString.fromString(txtUsers_New_Account.Text,@UA.User);
  FLoading:=True;
  Try
    if uStorage.UserAccount_Exists(uStorage.Module,UA.User,FDomainP^.ID) then begin
      // Display Dialog Box showing that the user with that name can't be added again.
      txtUsers_New_Account.SetFocus;
    end else begin
      UA.DomainID:=FDomainP^.ID;
      uVarString.fromString(txtUsers_New_Account.Text,@UA.User);
      uVarString.fromString(txtUsers_New_First.Text,@UA.First);
      uVarString.fromString(txtUsers_New_Last.Text,@UA.Last);
      uVarString.fromString(txtUsers_New_Password.Text,@UA.Password);
      UA.Enabled:=true;
      UA.bPOP3Type:=FDomainP^.Default_POP3_Type;
      UA.Quota:=FDomainP^.Default_Quota;
      UA.SpamFilter:=FDomainP^.Default_SpamFiltering;
      UA.SRS_CalEdit:=FDomainP^.Default_Calendar;
      UA.SRS_RSSEdit:=FDomainP^.Default_RSS;
      UA.ContentManagement:=FDomainP^.Default_ContentMngt;
      UA.WebMail:=FDomainP^.Default_WebMail;
      if uStorage.UserAccount_Create(uStorage.Module,UA,FDomainP^.ID) then begin
        liItem:=lvUsers.Items.Add;
        liItem.Caption:=txtUsers_New_Account.Text;
        liItem.SubItems.Add(txtUsers_New_First.Text);
        liItem.SubItems.Add(txtUsers_New_Last.Text);
        liItem.SubItems.Add('');
        liItem.SubItems.Add('0');
        liItem.Data:=Pointer(UA.ID);
        iIndex:=Length(Accounts);
        SetLength(Accounts,iIndex+1);
        Copy(UA,Accounts[iIndex]);
        {$i frmConsole.Domains.Users.Clear.inc}
        If lvDomains.Selected<>nil then
          lvDomains.Selected.SubItems[0]:=IntToStr(uStorage.UserAccount_Count(uStorage.Module,FDomainP^.ID));
      end;
    end;
  finally
    FLoading:=False;
    Empty(UA);
  end;
end;

procedure TConsoleForm.btnUsersFindClick(Sender: TObject);
begin

end;

procedure TConsoleForm.btnWLDNSItemAddClick(Sender: TObject);
var
  iIndex:integer;
  liDNS:TListItem;
begin
  iIndex:=Length(DNS_WhiteLists);
  SetLength(DNS_WhiteLists,iIndex+1);
  DNS_WhiteLists[iIndex].Kind:=uStorage.dnskWhiteList;
  DNS_WhiteLists[iIndex].ID:=0;
  DNS_WhiteLists[iIndex].IP:=0;

  uStorage.Config_DNS_Add(uStorage.Module,DNS_WhiteLists[iIndex]);
  liDNS:=lvDNSWL.Items.Add;
  liDNS.Caption:='0.0.0.0';
  liDNS.SubItems.Add(IntToStr(DNS_WhiteLists[iIndex].ID));
  lvDNSWL.Selected:=liDNS;
end;

procedure TConsoleForm.btnDNSItemRemoveClick(Sender: TObject);
var
  iID:Int64;
  iIndex:integer;
begin
  FLoading:=true;
  Try
    btnDNSItemRemove.Enabled:=false;
    btnDNSItemAdd.Enabled:=true;
    Edit21.Clear;
    Edit22.Clear;
    Edit27.Clear;
    Edit28.Clear;
    if lvDNSRegular.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSRegular.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_Hosts,iID);
      if iIndex<>-1 then begin
        uStorage.Config_DNS_Delete(uStorage.Module,DNS_Hosts[iIndex]);
        uStorage.Remove(DNS_Hosts,iIndex);
        lvDNSRegular.Selected.Delete;

      end;
    end;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.Button12Click(Sender: TObject);
begin

end;

procedure TConsoleForm.Button7Click(Sender: TObject);
begin

end;

procedure TConsoleForm.Button8Click(Sender: TObject);
begin

end;

procedure TConsoleForm.Button9Click(Sender: TObject);
begin

end;

procedure TConsoleForm.cbDomain_ClustersChange(Sender: TObject);
var
  iIndex:integer;
  iLcv:integer;
begin
  if FLoading or (cbDomain_Clusters.ItemIndex=-1) then exit;
  FDomainServices.Cluster.ID:=StrToIntDef(cbDomain_Clusters.Items.ValueFromIndex[cbDomain_Clusters.ItemIndex],-1);
  cbDomain_Nodes.Clear;
  if (FDomainServices.Cluster.ID<>-1) and MatrixNodes_List(FDomainServices.Cluster,FDomainNodes) then begin
    for iLcv:=0 to High(FDomainNodes) do begin
      iIndex:=cbDomain_Nodes.Items.Add(uVarString.toString(FDomainNodes[iLcv].Alias));
      cbDomain_Nodes.Items.ValueFromIndex[iIndex]:=IntToStr(FDomainNodes[iLcv].ID);
    end;
  end;
end;

procedure TConsoleForm.cbDomain_DefaultsClick(Sender: TObject);
begin
end;

procedure TConsoleForm.cbDomain_DefaultsItemClick(Sender: TObject;
  Index: integer);
begin
  if FLoading then Exit;
  Case Index of
    0 : FDomainP^.Default_SiteStats:=cbDomain_Defaults.State[0]=cbChecked;
    1 : FDomainP^.Default_Calendar:=cbDomain_Defaults.State[1]=cbChecked;
    2 : FDomainP^.Default_RSS:=cbDomain_Defaults.State[2]=cbChecked;
    3 : FDomainP^.Default_ContentMngt:=cbDomain_Defaults.State[3]=cbChecked;
    4 : FDomainP^.Default_SpamFiltering:=cbDomain_Defaults.State[4]=cbChecked;
    5 : FDomainP^.Default_WebMail:=cbDomain_Defaults.State[5]=cbChecked;
  end;
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.cbDomain_ServiceChange(Sender: TObject);
Const
  CHECK_SCALE:Array[boolean] of Integer=(0,1);
var
  Scale:integer;
  msKind:integer;
  msIndex:integer;
begin
  if FLoading then Exit;
  FLoading:=True;
  Try
    if FTempScale=0 then
      FTempScale:=1;
    CHECK_SCALE[true]:=FTempScale;
    Scale:=CHECK_SCALE[cbDomain_Service.Checked];
    tbDomainScale.Position:=Scale;
    {$i frmConsole.Domain.ScaleChange.inc}
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.E(Sender: TObject; var Key: char);
begin

end;

procedure TConsoleForm.Edit13Change(Sender: TObject);
begin
  If FLoading then exit;
  FClusterNode_IP[0]:=Edit13.Text;
end;

procedure TConsoleForm.Edit13KeyPress(Sender: TObject; var Key: char);
begin
  if (System.Pos(Key,uInt64Array.Digits)=0) and (Key<>#8)then
    Key:=#0;
end;

procedure TConsoleForm.Edit14Change(Sender: TObject);
begin
  If FLoading then exit;
  FClusterNode_IP[1]:=Edit14.Text;
end;

procedure TConsoleForm.Edit15Change(Sender: TObject);
begin
  If FLoading then exit;
  FClusterNode_IP[2]:=Edit15.Text;
end;

procedure TConsoleForm.Edit15KeyPress(Sender: TObject; var Key: char);
begin

end;

procedure TConsoleForm.Edit16Change(Sender: TObject);
begin
  If FLoading then exit;
  FClusterNode_IP[3]:=Edit16.Text;
end;

procedure TConsoleForm.Edit18Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Accounts:=Edit18.text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit19Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_HTTP_Logs:=Edit19.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit21Change(Sender: TObject);
begin
  If FLoading then exit;
  FDNS_HOST_IP[0]:=IntToStr(StrToIntDef(Edit21.Text,0));
  UpdateSelectedDNSServer(dnskRegular);
end;

procedure TConsoleForm.Edit22Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_HOST_IP[1]:=IntToStr(StrToIntDef(Edit22.Text,0));
  UpdateSelectedDNSServer(dnskRegular);
end;

procedure TConsoleForm.Edit23Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Domain_Storage_Folders:=Edit23.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit24Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Syndication_Items:=Edit24.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit25Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Domain_Storage_Files:=Edit25.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit26Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_DNS:=Edit26.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit27Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_HOST_IP[2]:=IntToStr(StrToIntDef(Edit27.Text,0));
  UpdateSelectedDNSServer(dnskRegular);
end;

procedure TConsoleForm.Edit28Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_HOST_IP[3]:=IntToStr(StrToIntDef(Edit28.Text,0));
  UpdateSelectedDNSServer(dnskRegular);
end;

procedure TConsoleForm.Edit29Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Matrix_Services:=Edit29.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit30Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Roster_Items:=Edit30.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit31Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_CSS:=Edit31.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit32Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_BL_IP[0]:=IntToStr(StrToIntDef(Edit32.Text,0));
  UpdateSelectedDNSServer(dnskBlackList);
end;

procedure TConsoleForm.Edit33Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_BL_IP[1]:=IntToStr(StrToIntDef(Edit33.Text,0));
  UpdateSelectedDNSServer(dnskBlackList);
end;

procedure TConsoleForm.Edit34Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Keywords:=Edit34.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit35Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_RSS_Channels:=Edit35.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit36Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_RSS_Items:=Edit36.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit37Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_Calendar_Events:=Edit37.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit38Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_BL_IP[2]:=IntToStr(StrToIntDef(Edit38.Text,0));
  UpdateSelectedDNSServer(dnskBlackList);
end;

procedure TConsoleForm.Edit39Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_CONTENT:=Edit39.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit40Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_BLOCK_LIST:=Edit40.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit41Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Syndication_Feeds:=Edit41.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit42Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Syndication_Admin:=Edit42.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit43Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_User_Storage_Files:=Edit43.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit44Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_User_Storage_Folders:=Edit44.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit45Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Syndication_Streams:=Edit45.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit46Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Providers_Store:=Edit46.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit47Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Query_Store:=Edit47.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit48Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Result_Store:=Edit48.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit49Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_SSNL_Store:=Edit49.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit50Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Group_Store:=Edit50.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit51Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Group_Store_ControlList:=Edit51.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit52Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_QueryResults_Store:=Edit52.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit53Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_TempSearchUser_Store:=Edit53.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit54Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_TempSearchUserInteraction_Store:=Edit54.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit55Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Matrix_Nodes:=Edit55.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit56Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_Matrix_Cluster_Info:=Edit56.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit57Change(Sender: TObject);
begin
  if FLoading then Exit;
  uStorage.DB_Table_ALLOW_LIST:=Edit57.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit58Change(Sender: TObject);
begin
  if FLoading then exit;
  uStorage.DB_Table_SearchSessionData:=Edit58.Text;
  uStorage.SaveINIFile;
end;

procedure TConsoleForm.Edit59Change(Sender: TObject);
begin
  if FLoading then exit;
  FDNS_BL_IP[3]:=IntToStr(StrToIntDef(Edit59.Text,0));
  UpdateSelectedDNSServer(dnskBlackList);
end;

procedure TConsoleForm.Edit64Change(Sender: TObject);
begin
  If FLoading then exit;
  FDNS_WL_IP[0]:=IntToStr(StrToIntDef(Edit64.Text,0));
  UpdateSelectedDNSServer(dnskWhiteList);
end;

procedure TConsoleForm.Edit65Change(Sender: TObject);
begin
  If FLoading then exit;
  FDNS_WL_IP[1]:=Edit65.Text;
  UpdateSelectedDNSServer(dnskWhiteList);
end;

procedure TConsoleForm.Edit66Change(Sender: TObject);
begin
  If FLoading then exit;
  FDNS_WL_IP[2]:=Edit66.Text;
  UpdateSelectedDNSServer(dnskWhiteList);
end;

procedure TConsoleForm.Edit67Change(Sender: TObject);
begin
  If FLoading then exit;
  FDNS_WL_IP[3]:=Edit67.Text;
  UpdateSelectedDNSServer(dnskWhiteList);
end;

procedure TConsoleForm.Edit9Change(Sender: TObject);
begin

end;

procedure TConsoleForm.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  uDatabase.Disconnect(Module.SessionID);
  Application.Terminate;
end;

procedure TConsoleForm.lvDomainServicesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
var
  msKind:integer;
  Scale:Integer;
begin
  if FLoading then Exit;
  msKind:=MatrixService_FromLongName(Item.Caption);
  if msKind<>-1 then begin
     // Service kind is supported.  Display appropriate Scale here
     FLoading:=True;
     Try
       case msKind of
         mkXMPPCToS  :  Scale:=FDomainP^.XMPP_ClientToServer_Scale;
         mkXMPPSToS  :  Scale:=FDomainP^.XMPP_ServerToServer_Scale;
         mkPOP3      :  Scale:=FDomainP^.POP3_Scale;
         mkSMTP      :  Scale:=FDomainP^.SMTP_Scale;
         mkHTTP      :  Scale:=FDomainP^.HTTP_Scale;
         mkHTTPS     :  Scale:=FDomainP^.HTTPS_Scale;
         mkDNS       :  Scale:=FDomainP^.DNS_Scale;
         mkLDAP      :  Scale:=FDomainP^.LDAP_Scale;
         mkIMAP      :  Scale:=FDomainP^.IMAP_Scale;
         mkBMail     :  Scale:=FDomainP^.BM_Scale;
       end;
       if Scale>0 then
         FTempScale:=Scale;
       cbDomain_Service.Checked:=Scale>0;
       tbDomainScale.Position:=Scale;
       cbDomain_Service.Enabled:=true;
       tbDomainScale.Enabled:=true;
     finally
       FLoading:=False;
     end;
  end else begin
    // Service is not found. disable settings box.
    FLoading:=True;
    Try
      cbDomain_Service.Checked:=false;
      cbDomain_Service.Enabled:=false;
      tbDomainScale.Position:=0;
      tbDomainScale.Enabled:=false;
    finally
      FLoading:=False;
    end;
  end;
end;

procedure TConsoleForm.lvDNSRegularSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  iLen:integer;
begin
  FLoading:=true;
  Try
    Selected:=Item<>nil;
    if Selected then begin
      Edit28.Enabled:=true;
      Edit27.Enabled:=true;
      Edit22.Enabled:=true;
      Edit21.Enabled:=true;
      uStringArray.fromString(@FDNS_HOST_IP,Item.Caption,'.');
      SetLength(FDNS_HOST_IP,4);// Add or truncate
      // Assign Editor
      Edit21.Text:=FDNS_HOST_IP[0];
      Edit22.Text:=FDNS_HOST_IP[1];
      Edit27.Text:=FDNS_HOST_IP[2];
      Edit28.Text:=FDNS_HOST_IP[3];

      btnDNSItemAdd.Enabled:=true;
      btnDNSItemRemove.Enabled:=true;
    end else begin
      Edit21.Clear;
      Edit22.Clear;
      Edit27.Clear;
      Edit28.Clear;
      Edit21.Enabled:=false;
      Edit22.Enabled:=false;
      Edit27.Enabled:=false;
      Edit28.Enabled:=false;
      btnDNSItemAdd.Enabled:=true;
      btnDNSItemRemove.Enabled:=false;
    end;
  finally
    FLoading:=False;
  end;

end;

procedure TConsoleForm.lvHSWLSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
if Item<>nil then
    txtHSWLHI.Text:=Item.Caption
  else
    txtHSWLHI.Clear;
end;

procedure TConsoleForm.lvClusterNodesSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin

end;

procedure TConsoleForm.lvUsersDblClick(Sender: TObject);
var
  iID:Int64;
  iIndex:Integer;
begin
  if lvUsers.Selected<>nil then begin
    iID:=Int64(lvUsers.Selected.Data);
    iIndex:=IndexOf(Accounts,iID);
    if iIndex<>-1 then begin
      FLoading:=true;
      Try
       FUserP:=@Accounts[iIndex];
       {$i frmConsole.Domain.User.Edit.inc}
      finally
        FLoading:=false;
      end;
    end;
  end;
end;

procedure TConsoleForm.lvUsersSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  iID:Int64;
  iIndex:integer;
begin
  If lvUsers.Selected<>Nil then begin
    iID:=Int64(lvUsers.Selected.Data);
    iIndex:=uStorage.IndexOf(Accounts,iID);
    if iIndex<>-1 then
      FUserP:=@Accounts[iIndex];
  end;
end;

procedure TConsoleForm.MenuItem9Click(Sender: TObject);
begin

end;

procedure TConsoleForm.MI_File_New_ClusterClick(Sender: TObject);
begin

end;

procedure TConsoleForm.MI_File_New_NodeClick(Sender: TObject);
begin

end;

procedure TConsoleForm.MI_File_New_UserClick(Sender: TObject);
begin

end;

procedure TConsoleForm.MenuItem17Click(Sender: TObject);
begin
  uDatabase.Disconnect(uStorage.Module.SessionID);
end;

procedure TConsoleForm.MenuItem5Click(Sender: TObject);
begin

end;

procedure TConsoleForm.MI_File_NewClick(Sender: TObject);
begin
  MI_File_New_Node.Enabled:=(FClusterP<>nil);
  MI_File_New_User.Enabled:=(FDomainP<>nil);
end;

procedure TConsoleForm.MI_PU_Domain_User_DeleteClick(Sender: TObject);
begin

end;

procedure TConsoleForm.pcDomainChange(Sender: TObject);
begin

end;

procedure TConsoleForm.pcDomainChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange:=not((pcDomain.ActivePage=tsUser) and tsUser.TabVisible);
end;

procedure TConsoleForm.pcPagesChange(Sender: TObject);
begin

end;

procedure TConsoleForm.PU_ClustersPopup(Sender: TObject);
var
  bEnabled:boolean;
begin
  bEnabled:=lvClusters.Selected<>nil;
  MI_PU_Cluster_Edit.Enabled:=bEnabled;
  MI_PU_Cluster_Delete.Enabled:=bEnabled;
end;

procedure TConsoleForm.PU_Domain_UsersPopup(Sender: TObject);
var
  bEnabled:boolean;
begin
  bEnabled:=(lvUsers.Selected<>Nil);
  MI_PU_Domain_User_Edit.Enabled:=bEnabled;
  MI_PU_Domain_User_Unlock.Enabled:=bEnabled;
  MI_PU_Domain_User_Delete.Enabled:=bEnabled;
end;

procedure TConsoleForm.sbUserClick(Sender: TObject);
begin

end;

procedure TConsoleForm.seDomainAdminTextAreaColumnsChange(Sender: TObject);
begin
  if FLoading then exit;

end;

procedure TConsoleForm.seDomain_Default_QuotaChange(Sender: TObject);
begin
  if FLoading then Exit;
  FDomainP^.Default_Quota:=seDomain_Default_Quota.Value;
  uStorage.Domain_Update(uStorage.Module,FDomainP^);
end;

procedure TConsoleForm.StatusBarResize(Sender: TObject);
begin
  StatusBar.Panels.Items[0].Width:=StatusBar.ClientWidth-StatusBar.Panels.Items[1].Width;
end;

procedure TConsoleForm.TabSheet5ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin

end;

procedure TConsoleForm.tsPrefDTSearchContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TConsoleForm.tbbClustersDeleteClick(Sender: TObject);
begin

end;

procedure TConsoleForm.tbbClustersEdit2Click(Sender: TObject);
var
  iID:Int64;
  iIndex:integer;
  iLcv:integer;
  liItem:TListItem;
begin
  FLoading:=True;
  Try
    If (lvClusterNodes.Selected<>nil) then begin
      iID:=Int64(lvClusterNodes.Selected.Data);
      iIndex:=IndexOf(FClusterNodes,iID);
      if iIndex<>-1 then begin
        FClusterNodeP:=@FClusterNodes[iIndex];
        txtClusterNodeName.Text:=uVarString.toString(FClusterNodeP^.Alias);
        uStringArray.fromString(@FClusterNode_IP,uSocketUtils.InAddrToStr(FClusterNodeP^.IP),'.');
        SetLength(FClusterNode_IP,4);
        Edit13.Text:=FClusterNode_IP[0];
        Edit14.Text:=FClusterNode_IP[1];
        Edit15.Text:=FClusterNode_IP[2];
        Edit16.Text:=FClusterNode_IP[3];
        gbClustersNewNode.Visible:=true;
      end;
    end;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.tbbClustersEditClick(Sender: TObject);
var
  iID:Int64;
  iIndex:Integer;
begin
  if lvClusters.Selected=nil then exit;
  iID:=Int64(lvClusters.Selected.Data);
  iIndex:=IndexOf(Clusters,iID);
  if iIndex<>-1 then
    Display_Cluster_Editor(@Clusters[iIndex]);
end;

procedure TConsoleForm.tbbDomainServiceNewClick(Sender: TObject);
begin
  tbbDomainServiceNew.DropdownMenu.PopUp;
end;

procedure TConsoleForm.tbbClustersNewClick(Sender: TObject);
begin
  Empty(FClusterNode_IP);
  SetLength(FClusterNode_IP,4);
  FClusterNodeP:=Nil;
  txtClusterNodeName.Clear;
  Edit13.Clear;
  Edit14.Clear;
  Edit15.Clear;
  Edit16.Clear;
  gbClustersNewNode.visible:=true;
  btnClusterNewNode.Enabled:=false;
end;

procedure TConsoleForm.tbbDomain_Users_FindClick(Sender: TObject);
var
  iLcv:integer;
  li:TListItem;
begin
  lvUsers.Clear;
  uStorage.UserAccount_Find(uStorage.Module,Accounts,FDomainP^.ID,Like_Prep(txtUsersFind.Text));
  {$i frmConsole.Users.List.inc}
end;

procedure TConsoleForm.tbbDomain_User_DeleteClick(Sender: TObject);
var
  iIndex:integer;
  iID:Int64;
begin
  if lvUsers.Selected=nil then exit;
  iID:=Int64(lvUsers.Selected.Data);
  iIndex:=IndexOf(Accounts,iId);
  if iIndex<>-1 then begin
    uStorage.UserAccount_Delete(uStorage.Module,Accounts[iIndex],FDomainP^.ID);
    Empty(Accounts[iIndex]);
    lvUsers.Selected.Delete;
    If lvDomains.Selected<>nil then
      lvDomains.Selected.SubItems[0]:=IntToStr(uStorage.UserAccount_Count(uStorage.Module,FDomainP^.ID));
  end;
end;

procedure TConsoleForm.tbbDomain_User_NewClick(Sender: TObject);
begin
  FLoading:=true;
  Try
    {$i frmConsole.Domains.Users.Clear.inc}
    gbDomain_Users_New.Visible:=true;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.tbbDomain_User_UnlockClick(Sender: TObject);
begin
  if (lvUsers.Selected<>nil) and (FUserP<>Nil) then begin
    FUserP^.LockCount:=0;
    FUserP^.Enabled:=true;
    lvUsers.Selected.SubItems[3]:='0';
    uStorage.UserAccount_Save(uStorage.Module,FUserP^);
  end;
end;

procedure TConsoleForm.tbDomainScaleChange(Sender: TObject);
var
  msKind:integer;
  msIndex:integer;
  Scale:integer;
begin
  if FLoading then Exit;
  FLoading:=True;
  Try
    if tbDomainScale.Position>0 then
      FTempScale:=tbDomainScale.Position;
    cbDomain_Service.Checked:=tbDomainScale.Position>0;
    Scale:=tbDomainScale.Position;
    {$i frmConsole.Domain.ScaleChange.inc}
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.tsDomainUsersContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TConsoleForm.tsWelcomeContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
end;

procedure TConsoleForm.UpdateSelectedDNSServer(Kind:Byte);
var
  iID:Int64;
  iIndex:integer;

  procedure Push_Regular;
  begin
    If lvDNSRegular.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSRegular.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_Hosts,iID);
      if iIndex<>-1 then begin
        lvDNSRegular.Selected.Caption:=uStringArray.toString(FDNS_HOST_IP,'.');
        DNS_Hosts[iIndex].IP:=uSocketUtils.InAddrFromStr(lvDNSRegular.Selected.Caption);
        uStorage.Config_DNS_Set(uStorage.Module,DNS_Hosts[iIndex]);
      end;
    end;
  end;

  procedure Push_BlackList;
  begin
    If lvDNSBL.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSBL.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_BlackLists,iID);
      if iIndex<>-1 then begin
        lvDNSBL.Selected.Caption:=uStringArray.toString(FDNS_BL_IP,'.');
        DNS_BlackLists[iIndex].IP:=uSocketUtils.InAddrFromStr(lvDNSBL.Selected.Caption);
        uStorage.Config_DNS_Set(uStorage.Module,DNS_BlackLists[iIndex]);
      end;
    end;
  end;

  procedure Push_WhiteList;
  begin
    If lvDNSBL.Selected<>nil then begin
      iID:=StrToInt64Def(lvDNSWL.Selected.SubItems[0],0);
      iIndex:=uStorage.IndexOf(DNS_WhiteLists,iID);
      if iIndex<>-1 then begin
        lvDNSWL.Selected.Caption:=uStringArray.toString(FDNS_WL_IP,'.');
        DNS_WhiteLists[iIndex].IP:=uSocketUtils.InAddrFromStr(lvDNSWL.Selected.Caption);
        uStorage.Config_DNS_Set(uStorage.Module,DNS_WhiteLists[iIndex]);
      end;
    end;
  end;

begin
  Case Kind of
    dnskRegular : Push_Regular;
    dnskBlackList : Push_BlackList;
    dnskWhiteList : Push_WhiteList;
  end;
end;

procedure TConsoleForm.Display_Cluster_Editor(ClusterP:PMatrixCluster);
var
  iLcv:integer;
  liItem:TListItem;
begin
  FLoading:=True;
  Try
    FClusterP:=ClusterP;
    Empty(FClusterNodes);
    uStorage.MatrixNodes_List(FClusterP^,FClusterNodes);

    txtCluster_Name.Text:=uVarString.toString(ClusterP^.Group);
    txtCluster_Town.Text:=uVarString.toString(ClusterP^.Location.Locality);
    txtCluster_City.Text:=uVarString.toString(ClusterP^.Location.Area);
    txtCluster_State.Text:=uVarString.toString(ClusterP^.Location.Region);
    txtCluster_Country.Text:=uVarString.toString(ClusterP^.Location.Country);
    txtCluster_Street.Text:=uVarString.toString(ClusterP^.Location.Street);
    txtCluster_Building.Text:=uVarString.toString(ClusterP^.Location.Building);
    txtCluster_Floor.Text:=uVarString.toString(ClusterP^.Location.Floor);
    txtCluster_Room.Text:=uVarString.toString(ClusterP^.Location.Room);
    txtCluster_Zipcode.Text:=uVarString.toString(ClusterP^.Location.Zip);
    txtCluster_Description.Text:=uVarString.toString(ClusterP^.Location.Description);

    lvClusterNodes.Clear;
    For iLcv:=0 to High(FClusterNodes) do begin
      liItem:=lvClusterNodes.Items.Add;
      liItem.Caption:=uVarString.toString(FClusterNodes[iLcv].Alias);
      liItem.SubItems.Add(uSocketUtils.InAddrToStr(FClusterNodes[iLcv].IP));
      liItem.Data:=Pointer(FClusterNodes[iLcv].ID);
    end;
    AutoSizeColumns(lvClusterNodes);
    pcPages.ActivePage:=tsCluster;
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.Display_Domain_Editor(DomainP:PDomain);
const
 S_Enabled:Array[Boolean] of TCheckBoxState=(cbUnChecked,cbChecked);
var
 msIndex:Integer;
 msKind:Int64;
 iLcv:integer;
 Scale:integer;
 li:TListItem;
 iIndex:integer;

  procedure AddDefaultMatrixService(var Index:integer; Kind:Byte; Port:Integer; Scale:Byte);
  begin
     Index:=Length(FDomainServices.List);
     SetLength(FDomainServices.List,Index+1);
     Empty(FDomainServices.List[Index]);
     // Add Defaults Now
     FDomainServices.List[Index].DomainID:=FDomainP^.ID;
     FDomainServices.List[Index].Kind:=Kind;
     FDomainServices.List[Index].Port:=Port;
     FDomainServices.List[Index].Scale:=Scale;
     uStorage.MatrixService_Create(FDomainServices.List[Index]);
  end;

begin
  FLoading:=true;
  Try
    FDomainP:=DomainP;
    cbDomain_Host.Text:=uVarString.ToString(DomainP^.Domain);
    txtDomain_FriendlyName.Text:=uVarString.ToString(DomainP^.FriendlyName);
    txtDomain_Postmaster.Text:=uVarString.ToString(DomainP^.Root);
    Empty(FDomainServices);
    Empty(Accounts);
    // Clear out All Default IDs
    if uStorage.MatrixServices_Fill(FDomainServices,FDomainP^.ID,MS_DEFAULT_SETTINGS) then begin
      // Check XMPP CtoS
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkXMPPCToS);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkXMPPCToS,XMPP_SERVER_TO_CLIENT_PORT,FDomainP^.XMPP_ClientToServer_Scale);
      // Check XMPP StoS
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkXMPPSToS);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkXMPPSToS,XMPP_SERVER_TO_SERVER_PORT,FDomainP^.XMPP_ServerToServer_Scale);
      // Check POP3
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkPOP3);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkPOP3,POP3_PORT,FDomainP^.POP3_Scale);
      // Check SMTP
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkSMTP);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkSMTP,SMTP_PORT,FDomainP^.SMTP_Scale);
      // Check HTTP
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkHTTP);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkHTTP,HTTP_PORT,FDomainP^.HTTP_Scale);
      // Check HTTPS
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkHTTPS);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkHTTPS,HTTPS_PORT,FDomainP^.HTTP_Scale);
      // Check DNS
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkDNS);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkDNS,DNS_PORT,FDomainP^.DNS_Scale);
      // Check LDAP
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkLDAP);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkLDAP,LDAP_PORT,FDomainP^.LDAP_Scale);
      // Check mkIMAP
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkIMAP);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkIMAP,IMAP_PORT,FDomainP^.IMAP_Scale);
      // Check mkBMail
      msIndex:=IndexOfDefaultService(FDomainServices,FDomainP^.ID,mkBMail);
      if msIndex=-1 then
        AddDefaultMatrixService(msIndex,mkBMail,BMAIL_PORT,FDomainP^.BM_Scale);
    end;
    seDomain_Default_Quota.Value:=FDomainP^.Default_Quota;
    cbDomain_Defaults.State[0]:=S_Enabled[FDomainP^.Default_SiteStats];
    cbDomain_Defaults.State[1]:=S_Enabled[FDomainP^.Default_Calendar];
    cbDomain_Defaults.State[2]:=S_Enabled[FDomainP^.Default_RSS];
    cbDomain_Defaults.State[3]:=S_Enabled[FDomainP^.Default_ContentMngt];
    cbDomain_Defaults.State[4]:=S_Enabled[FDomainP^.Default_SpamFiltering];
    cbDomain_Defaults.State[5]:=S_Enabled[FDomainP^.Default_WebMail];
    seDomainAdminTextAreaColumns.Value:=FDomainP^.Admin.iTextAreaCols;
    seDomainAdminTextAreaRowCount.Value:=FDomainP^.Admin.iTextAreaRows;
    txtDomain_Admin_Table.Text:=uVarstring.toString(FDomainP^.Admin.TableClass);
    txtDomain_Admin_Table_Header.Text:=uVarstring.toString(FDomainP^.Admin.THClass);
    txtDomain_Admin_Table_Rows.Text:=uVarString.toString(FDomainP^.Admin.TRClass);
    txtDomain_Admin_Table_Rows.Text:=uVarString.toString(FDomainP^.Admin.TRClass);
    txtDomain_Admin_Table_Cells.Text:=uVarString.toString(FDomainP^.Admin.TDClass);
    txtDomain_Admin_Table_Seps.Text:=uVarString.toString(FDomainP^.Admin.TSClass);
    txtDomain_Admin_Table_Footers.Text:=uVarstring.toString(FDomainP^.Admin.TFClass);
    txtDomain_Admin_Table_Images.Text:=uVarstring.toString(FDomainP^.Admin.TIClass);
    txtDomain_Admin_Combo.Text:=uVarString.toString(FDomainP^.Admin.ComboClass);
    txtDomain_Admin_Inputs.Text:=uVarString.toString(FDomainP^.Admin.InputClass);
    txtDomain_Admin_RSS.Text:=uVarString.toString(FDomainP^.Admin.RSSIconURL);
    txtDomain_Admin_Calendar.Text:=uVarString.toString(FDomainP^.Admin.CalIconURL);
    txtDomain_Admin_Logs.Text:=uVarString.toString(FDomainP^.Admin.StatsIconURL);
    txtDomain_Admin_GoButton.Text:=uVarString.toString(FDomainP^.Admin.GoButtonURL);

    for iLcv:=0 to lvDomainServices.Items.Count-1 do begin
      msKind:=MatrixService_FromLongName(lvDomainServices.Items[iLcv].Caption);
      if msKind<>-1 then begin
        case msKind of
           mkXMPPCToS  :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.XMPP_ClientToServer_Scale);
           mkXMPPSToS  :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.XMPP_ServerToServer_Scale);
           mkPOP3      :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.POP3_Scale);
           mkSMTP      :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.SMTP_Scale);
           mkRelay     :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.RELAY_Scale);
           mkHTTP      :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.HTTP_Scale);
           mkHTTPS     :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.HTTPS_Scale);
           mkDNS       :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.DNS_Scale);
           mkLDAP      :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.LDAP_Scale);
           mkIMAP      :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.IMAP_Scale);
           mkBMail     :  lvDomainServices.Items[iLcv].SubItems[0]:=IntToStr(FDomainP^.BM_Scale);
         end;
      end;
    end;
    if lvDomainServices.Selected<>nil then begin
      msKind:=MatrixService_FromLongName(lvDomainServices.Selected.Caption);
      case msKind of
         mkXMPPCToS  :  Scale:=FDomainP^.XMPP_ClientToServer_Scale;
         mkXMPPSToS  :  Scale:=FDomainP^.XMPP_ServerToServer_Scale;
         mkPOP3      :  Scale:=FDomainP^.POP3_Scale;
         mkSMTP      :  Scale:=FDomainP^.SMTP_Scale;
         mkRelay     :  Scale:=FDomainP^.RELAY_Scale;
         mkHTTP      :  Scale:=FDomainP^.HTTP_Scale;
         mkHTTPS     :  Scale:=FDomainP^.HTTPS_Scale;
         mkDNS       :  Scale:=FDomainP^.DNS_Scale;
         mkLDAP      :  Scale:=FDomainP^.LDAP_Scale;
         mkIMAP      :  Scale:=FDomainP^.IMAP_Scale;
         mkBMail     :  Scale:=FDomainP^.BM_Scale;
       end;
       if Scale>0 then
         FTempScale:=Scale;
       tbDomainScale.Position:=Scale;
       cbDomain_Service.Checked:=Scale>0;
    end else begin
      tbDomainScale.Position:=0;
      cbDomain_Service.Checked:=false;
    end;
    // Now Load Any User Accounts with Like and Find Box
    {$i frmConsole.Domain.Users.User.Clear.inc}
    if (Length(txtUsersFind.Text)>0) then
      uStorage.UserAccount_Find(uStorage.Module,Accounts,FDomainP^.ID,Like_Prep(txtUsersFind.Text))
    else if (uStorage.UserAccount_Count(uStorage.Module,FDomainP^.ID)<200) then
      uStorage.UserAccount_Find(uStorage.Module,Accounts,FDomainP^.ID,Like_Prep(''));
    // Populate Search Box
    {$i frmConsole.Users.List.inc}
    // Populate Node Services
    lvDomainNodeServices.Clear;
    uStorage.MatrixServices_Fill(FDomainServices,FDomainP^.ID);
    for iLcv:=0 to high(FDomainServices.List) do begin
      li:=lvDomainNodeServices.Items.Add;
      li.Caption:=AliasOf(Clusters,FDomainServices.List[iLcv].ClusterID);
      li.SubItems.Add(AliasOf(Nodes,FDomainServices.List[iLcv].NodeID));
      li.SubItems.Add(mkLongNames[FDomainServices.List[iLcv].Kind]);
      li.SubItems.Add(uSocketUtils.InAddrToStr(FDomainServices.List[iLcv].IP));
      li.SubItems.Add(IntToStr(FDomainServices.List[iLcv].Port));
      li.SubItems.Add(IntToStr(FDomainServices.List[iLcv].Scale));
      li.Data:=Pointer(FDomainServices.List[iLcv].ID);
    end;
    // Display GUI
    pcDomain.ActivePage:=tsDomainUsers;
    pcPages.ActivePage:=tsDomain;
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.LoadDomains;
var
  liItem:TListItem;
  iLcv:integer;
begin
  FLoading:=True;
  Try
    lvDomains.Clear;
    cbDomain_Host.Clear;
    cbDomain_Host.Items.Clear;
    Empty(Domains);
    FDomainP:=nil;
    uStorage.Domain_List(uStorage.Module,Domains);
    for iLcv:=0 to High(Domains) do begin
      liItem:=lvDomains.Items.Add;
      liItem.Caption:=uVarString.toString(Domains[iLcv].Domain);
      cbDomain_Host.Items.Add(liItem.Caption);
      liItem.Data:=@Domains[iLcv];
      liItem.SubItems.Add(IntToStr(uStorage.UserAccount_Count(uStorage.Module,Domains[iLcv].ID)));
    end;
    AutoSizeColumns(lvDomains);
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.LoadNodes;
begin
  uStorage.MatrixNodes_List(Nodes);
end;

procedure TConsoleForm.LoadContentTypes;
var
  liItem:TListItem;
  iLcv:integer;
  iIndex:integer;
begin
  FLoading:=True;
  Try
    lvContentTypes.Clear;
    txtContentTypeExtension.Clear;
    txtContentTypeKind.Clear;
    Empty(uStorage.ContentTypes);
    uStorage.LoadContentTypes;
    for iLcv:=0 to High(ContentTypes) do begin
      liItem:=lvContentTypes.Items.Add;
      liItem.Caption:=ContentTypes[iLcv].Ext;
      liItem.SubItems.Add(ContentTypes[iLcv].Kind);
      liItem.Data:=@ContentTypes[iLcv];
      liItem.Cut:=hHTTP.IndexOf(ctDefaultExtensions,ContentTypes[iLcv].Ext)>-1;
    end;
    AutoSizeColumns(lvContentTypes);
  finally
    FLoading:=False;
  end;
end;

procedure TConsoleForm.LoadClusters;
var
  liItem:TListItem;
  iLcv:integer;
  iIndex:integer;
begin
  FLoading:=True;
  Try
    lvClusters.Clear;
    cbDomain_Clusters.Clear;
    cbDomain_Nodes.Clear;
    Empty(Clusters);
    uStorage.Cluster_List(Clusters);
    For iLcv:=0 to High(Clusters) do begin
      liItem:=lvClusters.Items.Add;
      liItem.Caption:=uVarString.toString(Clusters[iLcv].Group);
      iIndex:=cbDomain_Clusters.Items.Add(liItem.Caption);
      cbDomain_Clusters.Items.ValueFromIndex[iIndex]:=IntToStr(Clusters[iLcv].ID);
      liItem.SubItems.Add(uVarString.toString(Clusters[iLcv].Location.Description));
      liItem.SubItems.Add(uVarString.toString(Clusters[iLcv].Location.Locality));
      liItem.SubItems.Add(uVarString.toString(Clusters[iLcv].Location.Area));
      liItem.SubItems.Add(uVarString.toString(Clusters[iLcv].Location.Region));
      liItem.SubItems.Add(uVarString.toString(Clusters[iLcv].Location.Country));
      liItem.Data:=Pointer(Clusters[iLcv].ID);
    end;
    AutoSizeColumns(lvClusters);
  finally
    FLoading:=false;
  end;
end;

procedure TConsoleForm.LoadSettings;
var
  iLcv:integer;
  li:TListItem;
begin
  FLoading:=true;

  // Reset Services and Scale for Domain Editor
  cbDomain_Service.Checked:=false;
  tbDomainScale.Position:=0;
  lvDomainServices.Clear;
  for iLcv:=0 to MK_MAX do begin
    li:=lvDomainServices.Items.Add;
    li.Caption:=mkLongNames[iLcv];
    li.SubItems.Add('0');
    li.SubItems.Add(mkDescriptions[iLcv]);
  end;

  txtHSBLHI.Clear;
  txtHSWLHI.Clear;

  lvHSBL.Clear;
  lvHSWL.Clear;
  lvContentFilters.Clear;
  Edit7.Clear;


  uStorage.Security_List_Fill(uStorage.Module,secContentFilter,Security_Content_Filters);
  for iLcv:=0 to High(Security_Content_Filters) do begin
    li:=lvContentFilters.Items.Add;
    li.Caption:=uVarString.toString(Security_Content_Filters[iLcv].Value);
    li.SubItems.Add(IntToStr(Security_Content_Filters[iLcv].ID));
  end;

  uStorage.Security_List_Fill(uStorage.Module,secBlackList,Security_Block_List);
  for iLcv:=0 to High(Security_Block_List) do begin
    li:=lvHSBL.Items.Add;
    li.Caption:=uVarString.toString(Security_Block_List[iLcv].Value);
    li.SubItems.Add(IntToStr(Security_Block_List[iLcv].ID));
  end;
  uStorage.Security_List_Fill(uStorage.Module,secWhiteList,Security_Allow_List);
  for iLcv:=0 to High(Security_Allow_List) do begin
    li:=lvHSWL.Items.Add;
    li.Caption:=uVarString.toString(Security_Allow_List[iLcv].Value);
    li.SubItems.Add(IntToStr(Security_Allow_List[iLcv].ID));
  end;
  Empty(DNS_Hosts);
  lvDNSRegular.Clear;
  uStorage.Config_DNS_Fill(uStorage.Module,DNS_Hosts,dnskRegular);
  for iLcv:=0 to High(DNS_Hosts) do begin
    li:=lvDNSRegular.Items.Add;
    li.Caption:=uSocketUtils.InAddrToStr(DNS_Hosts[iLcv].IP);
    li.SubItems.Add(IntToStr(DNS_Hosts[iLcv].ID));
  end;
  Empty(DNS_BlackLists);
  lvDNSBL.Clear;
  uStorage.Config_DNS_Fill(uStorage.Module,DNS_BlackLists,dnskBlackList);
  for iLcv:=0 to High(DNS_BlackLists) do begin
    li:=lvDNSBL.Items.Add;
    li.Caption:=uSocketUtils.InAddrToStr(DNS_BlackLists[iLcv].IP);
    li.SubItems.Add(IntToStr(DNS_BlackLists[iLcv].ID));
  end;
  Empty(DNS_WhiteLists);
  lvDNSWL.Clear;
  uStorage.Config_DNS_Fill(uStorage.Module,DNS_WhiteLists,dnskWhiteList);
  for iLcv:=0 to High(DNS_WhiteLists) do begin
    li:=lvDNSWL.Items.Add;
    li.Caption:=uSocketUtils.InAddrToStr(DNS_WhiteLists[iLcv].IP);
    li.SubItems.Add(IntToStr(DNS_WhiteLists[iLcv].ID));
  end;

  // Database Tables
  // (Domains)
  Edit17.Text:=uStorage.DB_Table_Domains;
  Edit19.Text:=uStorage.DB_Table_HTTP_Logs;
  Edit23.Text:=uStorage.DB_Table_Domain_Storage_Folders;
  Edit25.Text:=uStorage.DB_Table_Domain_Storage_Files;
  Edit34.Text:=uStorage.DB_Table_Keywords;
  Edit35.Text:=uStorage.DB_Table_RSS_Channels;
  Edit36.Text:=uStorage.DB_Table_RSS_Items;
  Edit37.Text:=uStorage.DB_Table_Calendar_Events;
  Edit39.Text:=uStorage.DB_Table_CONTENT;
  Edit40.Text:=uStorage.DB_Table_BLOCK_LIST;
  Edit57.Text:=uStorage.DB_Table_ALLOW_LIST;
  Edit26.Text:=uStorage.DB_Table_DNS;
  Edit31.Text:=uStorage.DB_Table_CSS;
  // User Database Tables
  Edit18.Text:=uStorage.DB_Table_Accounts;
  Edit30.Text:=uStorage.DB_Table_Roster_Items;
  Edit44.Text:=uStorage.DB_Table_User_Storage_Folders;
  Edit43.Text:=uStorage.DB_Table_User_Storage_Files;
  // Cluster Tables
  Edit56.Text:=uStorage.DB_Table_Matrix_Cluster_Info;
  Edit55.Text:=uStorage.DB_Table_Matrix_Nodes;
  Edit29.Text:=uStorage.DB_Table_Matrix_Services;
  // RSS Syndication Tables
  Edit42.Text:=uStorage.DB_Table_Syndication_Admin;
  Edit41.Text:=uStorage.DB_Table_Syndication_Feeds;
  Edit24.Text:=uStorage.DB_Table_Syndication_Items;
  Edit45.Text:=uStorage.DB_Table_Syndication_Streams;
  // Search System
  Edit46.Text:=uStorage.DB_Table_Providers_Store;
  Edit47.Text:=uStorage.DB_Table_Query_Store;
  Edit48.Text:=uStorage.DB_Table_Result_Store;
  Edit49.Text:=uStorage.DB_Table_SSNL_Store;
  Edit50.Text:=uStorage.DB_Table_Group_Store;
  Edit51.Text:=uStorage.DB_Table_Group_Store_ControlList;
  Edit52.Text:=DB_Table_QueryResults_Store;
  Edit53.Text:=DB_Table_TempSearchUser_Store;
  Edit54.Text:=DB_Table_TempSearchUserInteraction_Store;
  Edit58.Text:=DB_Table_SearchSessionData;

end;

initialization
  {$I frmConsole.lrs}

end.

